; D_HIS_CLAMP.PRO  by  R. KRAMM  07-OCT-2004
; ==========================================
;
FUNCTION osiris_his_clamp, P
;
;@C_HEADER.INC
;
;				removes hot pixels (events)
;				and replaces these by the average amplitude
;
;				- helpful for coherent noise removal on dark images -
; -------------------------------------------------------------------
;
PP = P
;
; -------------------------------------------------------------------
;
LEV = MIN(ABS(D_CUMUL_HIS(PP<39990L, MIN=0) - .05*N_ELEMENTS(PP)))
REM = !C
;
; -------------------------------------------------------------------
;
IF (REM LE 330L)  THEN  BEGIN
	PSO = WHERE(PP GT LONG((REM-220L)*1.2 + 270.5), CNT)  ; 50 DU off
	IF (CNT GT 0L)  THEN  PP(PSO) = MEAN(PP < LONG(LEV))
	RETURN, PP
ENDIF
;																 done
; -------------------------------------------------------------------
;															> 5 % bad
LIM = 600.	;3000. * ALOG10(D_VALUE(H, H_CCDCOLDT)/120.) > 600.
SZE = SIZE(PP)	&  DX = SZE(1)	&  DY = SZE(2)
;
MED = FLOAT(PP)
MED(0,   0) = MEDIAN(MEDIAN(MED(*,   0), 11), 3)
MED(0,DY-1) = MEDIAN(MEDIAN(MED(*,DY-1), 11), 3)
MED(0,   0) = ROTATE(MEDIAN(MEDIAN(ROTATE(MED(0,   *),3),11),3),1)
MED(DX-1,0) = ROTATE(MEDIAN(MEDIAN(ROTATE(MED(DX-1,*),3),11),3),1)
MED = MEDIAN(MEDIAN(MEDIAN(MED,3),11),21)
;
HOT = WHERE((PP-MED) GT LIM, CNT)
IF (CNT GT 0L)  THEN  PP(HOT) = MED(HOT)
;
; -------------------------------------------------------------------
;
LEV = MIN(ABS(D_CUMUL_HIS(PP<39990L, MIN=0) - .05*N_ELEMENTS(PP)))
REM = !C
;
; -------------------------------------------------------------------
;
IF (REM LE 3300L)  THEN  BEGIN
	PSO = WHERE(PP GT LONG((REM-220L)*1.2 + 270.5), CNT)  ; 50 DU off
	IF (CNT GT 0L)  THEN  PP(PSO) = MEAN(PP < LONG(LEV))
	RETURN, PP
ENDIF
;																 done
; -------------------------------------------------------------------
;
; STOP, 'STOP'
;
RETURN, PP
END